package com.yidianling.home.model

import com.yidianling.home.http.HomeHttp
import com.ydl.ydlcommon.data.http.BaseResponse
import com.ydl.ydlcommon.data.http.RxUtils
import com.yidianling.home.constract.IHomeContract
import com.yidianling.home.http.HomeBaseHttp
import com.yidianling.home.model.bean.*
import io.reactivex.Observable
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers

/**
 * @author <a href="https://www.jianshu.com/u/c1e5310dd724">xujian</a>
 * @描述:
 * @Copyright Copyright (c) 2019
 * @Company 壹点灵
 * @date 2019/02/13
 */
class HomeModelImpl: BaseHomeModelImpl(), IHomeContract.Model  {

    //领取优惠券
    override fun receiveCoupon(uid: String, couponIds: String): Observable<BaseResponse<Any>> {

        return HomeHttp.getInstance().receiveCoupon(uid, couponIds)
    }

    //获取优惠券
    override fun getCoupons(uid: String): Observable<BaseResponse<List<CouponBean>>> {

        return HomeHttp.getInstance().getCoupons(uid)
    }
    override fun getMeditation(): Observable<MeditationModuleBean> {
        return HomeBaseHttp.getInstance().getMeditationInfo().compose(RxUtils.resultJavaData())
            .subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread())
            .onErrorReturn { MeditationModuleBean(true) }
    }
}